---
title: EXT_shader_texture_lod
slug: Web/API/EXT_shader_texture_lod
tags:
  - API
  - Reference
  - WebGL
  - WebGL extensions
---
<div>{{APIRef("WebGL")}}</div>

<p>The <code><strong>EXT_shader_texture_lod</strong></code> extension is part of the <a href="/en-US/docs/Web/API/WebGL_API">WebGL API</a> and adds additional texture functions to the OpenGL ES Shading Language which provide the shader writer with explicit control of LOD (<a href="https://en.wikipedia.org/wiki/Level_of_detail">Level of detail</a>).</p>

<p>WebGL extensions are available using the {{domxref("WebGLRenderingContext.getExtension()")}} method. For more information, see also <a href="/en-US/docs/Web/API/WebGL_API/Using_Extensions">Using Extensions</a> in the <a href="/en-US/docs/Web/API/WebGL_API/Tutorial">WebGL tutorial</a>.</p>

<div class="note">
<p><strong>Availability:</strong> This extension is only available to {{domxref("WebGLRenderingContext", "WebGL1", "", 1)}} contexts. In {{domxref("WebGL2RenderingContext", "WebGL2", "", 1)}}, the functionality of this extension is available on the WebGL2 context by default. It requires GLSL <code>#version 300 es</code>.</p>
</div>

<h2 id="GLSL_built-in_functions">GLSL built-in functions</h2>

<p>The following new functions can be used in GLSL shader code, if this extension is enabled:</p>

<pre class="brush: cpp">vec4 texture2DLodEXT(sampler2D sampler, vec2 coord, float lod)
vec4 texture2DProjLodEXT(sampler2D sampler, vec3 coord, float lod)
vec4 texture2DProjLodEXT(sampler2D sampler, vec4 coord, float lod)
vec4 textureCubeLodEXT(samplerCube sampler, vec3 coord, float lod)
vec4 texture2DGradEXT(sampler2D sampler, vec2 P, vec2 dPdx, vec2 dPdy)
vec4 texture2DProjGradEXT(sampler2D sampler, vec3 P, vec2 dPdx, vec2 dPdy)
vec4 texture2DProjGradEXT(sampler2D sampler, vec4 P, vec2 dPdx, vec2 dPdy)
vec4 textureCubeGradEXT(samplerCube sampler, vec3 P, vec3 dPdx, vec3 dPdy)
</pre>

<h2 id="Examples">Examples</h2>

<p>Enabling the extensions:</p>

<pre class="brush: js">gl.getExtension('EXT_shader_texture_lod');
</pre>

<p>Shader code that avoids artifacts when wrapping texture coordinates:</p>

<pre class="brush: html">&lt;script type="x-shader/x-fragment"&gt;
#extension GL_EXT_shader_texture_lod : enable
#extension GL_OES_standard_derivatives : enable

uniform sampler2D myTexture;
varying vec2 texcoord;

void main(){
  gl_FragColor = texture2DGradEXT(myTexture, mod(texcoord, vec2(0.1, 0.5)),
                                  dFdx(texcoord), dFdy(texcoord));
}
&lt;/script&gt;</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('EXT_shader_texture_lod', '', 'EXT_shader_texture_lod')}}</td>
   <td>{{Spec2('EXT_shader_texture_lod')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p class="hidden">The compatibility table in this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>

<p>{{Compat("api.EXT_shader_texture_lod")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("WebGLRenderingContext.getExtension()")}}</li>
 <li>{{domxref("OES_standard_derivatives")}}</li>
</ul>
